/*
	$Id: ChildrenFilter.java 170 2006-04-08 21:16:55Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import java.util.ArrayList;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
   ҥΡɥե륿Ǥ
*/
public class ChildrenFilter {

    /** ե륿оݤȤʤΡ */
    private Node node;

    /**
       ҥΡɥե륿ޤ

       @param node ҤĥΡ
    */
    public ChildrenFilter(final Node node) {
	this.node = node;
    }

    /**
       ѥ˥ޥå̾ĻҤΥΡɥꥹȤޤ

       @param s ɽΥѥ
       @return ѥ˥ޥå̾ĻҤΥΡɥꥹ
    */
    public NodeList getDirectChildrenByTagName(final String s) {
        ArrayList<Node> v = new ArrayList<Node>();
        NodeList children = node.getChildNodes();
        for (int i = 0; i < children.getLength(); ++i) {
            Node child = children.item(i);
            if (!child.getNodeName().matches(s)) {
                continue;
            }
            v.add(child);
        }
        return new ChildrenNodeList(v);
    }

    /**
       ҥΡɤΥꥹȤǤ
    */
    private final class ChildrenNodeList implements NodeList {

	/** ΡɤΥꥹ */
	private ArrayList<Node> v;

	/**
	   ҥΡɤΥꥹȤޤ

	   @param v ΡɤΥꥹ
	*/
	private ChildrenNodeList(final ArrayList<Node> v) {
	    this.v = v;
	}

	public int getLength() {
	    return v.size();
	}

	public Node item(final int index) {
	    return v.get(index);
	}
    }
}
